/*******************************************************************************
Copyright (C) 2015 Annapurna Labs Ltd.

This file may be licensed under the terms of the Annapurna Labs Commercial
License Agreement.

Alternatively, this file can be distributed under the terms of the GNU General
Public License V2 as published by the Free Software Foundation and can be
found at http://www.gnu.org/licenses/gpl-2.0.html

Alternatively, redistribution and use in source and binary forms, with or
without modification, are permitted provided that the following conditions are
met:

    *     Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

    *     Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************/

/**
 * @addtogroup groupddr
 *
 *  @{
 * @file   al_hal_ddr_jedec_ddr3.h
 *
 * @brief  DDR JEDEC registers bits defines
 *
 */
#ifndef __AL_HAL_DDR_JEDEC_DDR3_H__
#define __AL_HAL_DDR_JEDEC_DDR3_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Mode Register 0 */
#define AL_DDR_JEDEC_DDR3_MR_BL_MASK		0x00000003
#define AL_DDR_JEDEC_DDR3_MR_BL_SHIFT		0

#define AL_DDR_JEDEC_DDR3_MR_BL_8_FIXED		\
	(0 << AL_DDR_JEDEC_DDR3_MR_BL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR_BC_4_8		\
	(1 << AL_DDR_JEDEC_DDR3_MR_BL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR_BT_MASK		0x00000008
#define AL_DDR_JEDEC_DDR3_MR_BT_SHIFT		3

#define AL_DDR_JEDEC_DDR3_MR_BT_SEQ		\
	(0 << AL_DDR_JEDEC_DDR3_MR_BT_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR_BT_INTRLVD		\
	(1 << AL_DDR_JEDEC_DDR3_MR_BT_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR_CL_MASK		0x00000074
#define AL_DDR_JEDEC_DDR3_MR_CL_SHIFT		2
#define AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2		4

#define AL_DDR_JEDEC_DDR3_MR_CL_5		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x1 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_6		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x2 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_7		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x3 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_8		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x4 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_9		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x5 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_10		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x6 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_11		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x7 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_12		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x0 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_13		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x1 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_CL_14		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT) |\
	(0x2 << AL_DDR_JEDEC_DDR3_MR_CL_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR_DR			0x00000100

#define AL_DDR_JEDEC_DDR3_MR_WR_MASK		0x00000E00
#define AL_DDR_JEDEC_DDR3_MR_WR_SHIFT		9

#define AL_DDR_JEDEC_DDR3_MR_WR_5		\
	(1 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_6		\
	(2 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_7		\
	(3 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_8		\
	(4 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_10		\
	(5 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_12		\
	(6 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_14		\
	(7 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)
#define AL_DDR_JEDEC_DDR3_MR_WR_16		\
	(0 << AL_DDR_JEDEC_DDR3_MR_WR_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR_PD_MASK		0x00001000
#define AL_DDR_JEDEC_DDR3_MR_PD_SHIFT		12

#define AL_DDR_JEDEC_DDR3_MR_PD_SLOW_EXIT	\
	(0 << AL_DDR_JEDEC_DDR3_MR_PD_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR_PD_FAST_EXIT	\
	(1 << AL_DDR_JEDEC_DDR3_MR_PD_SHIFT)

/* Mode Register 1 */
#define AL_DDR_JEDEC_DDR3_MR1_DE_MASK		0x00000001
#define AL_DDR_JEDEC_DDR3_MR1_DE_SHIFT		0

#define AL_DDR_JEDEC_DDR3_MR1_DE_EN		\
	(0 << AL_DDR_JEDEC_DDR3_MR1_DE_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR1_DE_DIS		\
	(1 << AL_DDR_JEDEC_DDR3_MR1_DE_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR1_DIC_MASK		0x00000022
#define AL_DDR_JEDEC_DDR3_MR1_DIC_SHIFT		1
#define AL_DDR_JEDEC_DDR3_MR1_DIC_SHIFT2	5

#define AL_DDR_JEDEC_DDR3_MR1_DIC_RZQ6		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR1_DIC_SHIFT) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_DIC_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR1_DIC_RZQ7		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR1_DIC_SHIFT) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_DIC_SHIFT2))

#define AL_DDR_JEDEC_DDR3_MR1_RTT_MASK		0x00000244
#define AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT		2
#define AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2	6
#define AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3	9

#define AL_DDR_JEDEC_DDR3_MR1_RTT_ODT_DIS		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3))

#define AL_DDR_JEDEC_DDR3_MR1_RTT_RZQ4		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3))

#define AL_DDR_JEDEC_DDR3_MR1_RTT_RZQ2		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT) |	\
	(0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3))

#define AL_DDR_JEDEC_DDR3_MR1_RTT_RZQ6		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT) |	\
	(0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3))

#define AL_DDR_JEDEC_DDR3_MR1_RTT_RZQ12		\
	((0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2) |	\
	(0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3))

#define AL_DDR_JEDEC_DDR3_MR1_RTT_RZQ8		\
	((0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT) |	\
	(0x0 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT2) |	\
	(0x1 << AL_DDR_JEDEC_DDR3_MR1_RTT_SHIFT3))

#define AL_DDR_JEDEC_DDR3_MR1_AL_MASK		0x00000018
#define AL_DDR_JEDEC_DDR3_MR1_AL_SHIFT		3

#define AL_DDR_JEDEC_DDR3_MR1_AL_DIS		\
	(0 << AL_DDR_JEDEC_DDR3_MR1_AL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR1_AL_CL_MINUS_1	\
	(1 << AL_DDR_JEDEC_DDR3_MR1_AL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR1_AL_CL_MINUS_2	\
	(2 << AL_DDR_JEDEC_DDR3_MR1_AL_SHIFT)

/* Mode Register 2 */
#define AL_DDR_JEDEC_DDR3_MR2_CWL_MASK		0x00000038
#define AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT		3

#define AL_DDR_JEDEC_DDR3_MR2_CWL_5		\
	(0 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_6		\
	(1 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_7		\
	(2 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_8		\
	(3 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_9		\
	(4 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_10		\
	(5 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_11		\
	(6 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_CWL_12		\
	(7 << AL_DDR_JEDEC_DDR3_MR2_CWL_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_RTTWR_MASK	0x00000600
#define AL_DDR_JEDEC_DDR3_MR2_RTTWR_SHIFT	9

#define AL_DDR_JEDEC_DDR3_MR2_RTTWR_ODT_DIS		\
	(0 << AL_DDR_JEDEC_DDR3_MR2_RTTWR_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_RTTWR_RZQ4		\
	(1 << AL_DDR_JEDEC_DDR3_MR2_RTTWR_SHIFT)

#define AL_DDR_JEDEC_DDR3_MR2_RTTWR_RZQ2		\
	(2 << AL_DDR_JEDEC_DDR3_MR2_RTTWR_SHIFT)

#ifdef __cplusplus
}
#endif

#endif

/** @} end of DDR group */

